//
//  AdlantisInterstitialNative
//  AdLantis SDK
//
//  Copyright 2014 Glossom, inc. All rights reserved.
//
//

#define USE_ADVIEW_IOS_NATIVE

using UnityEngine;
using System.Runtime.InteropServices;
using System;

namespace AdLantis.AdSdk
{
    public class AdlantisInterstitialNative
    {
        private static AdlantisInterstitialNative instance;
        
        public static AdlantisInterstitialNative Instance
        {
            get
            {
                if (instance == null)
                {
          //TODO reaise Error
                }
                
                return instance;
            }
        }
        
        public static void initWithPublisherId(string publisherId , string callbackName )
        {
          #if UNITY_EDITOR
          instance = new AdlantisInterstitialNative();
          #elif UNITY_IPHONE && USE_ADVIEW_IOS_NATIVE
      instance = new AdlantisInterstitialNativeIos(publisherId, callbackName);
          #elif UNITY_ANDROID
      instance = new AdlantisInterstitialNativeAndroid(publisherId, callbackName);
          #endif
        } 
        
        public virtual void Show()
        {
        }
        
        public virtual void Cancel()
        {
        }
        
        public virtual void Log(string s)
        {
        }
    }
    

#if UNITY_IPHONE && USE_ADVIEW_IOS_NATIVE && !UNITY_EDITOR

    public class AdlantisInterstitialNativeIos : AdlantisInterstitialNative
    {
      [DllImport("__Internal")]
    private static extern void _AdlantisIntersitial_Init(string publisherId, string callbackName);
      public AdlantisInterstitialNativeIos(string publisherId, string callbackName)
      {
      _AdlantisIntersitial_Init(publisherId, callbackName);
      }
  
      [DllImport("__Internal")]
      private static extern void _AdlantisIntersitial_Show();
      public override void Show()
      {
        _AdlantisIntersitial_Show();
      }

      [DllImport("__Internal")]
    private static extern void _AdlantisIntersitial_Cancel();
      public override void Cancel()
      {
        _AdlantisIntersitial_Cancel();
      }

    }

#elif UNITY_ANDROID

  public class AdlantisInterstitialNativeAndroid : AdlantisInterstitialNative
  {
    private AndroidJavaClass AdlantisUnityBridgeClass =  new AndroidJavaClass("jp.adlantis.android.unity.InterstitialUnityBridge");
    
    public static AndroidJavaObject getCurrentActivity() {
      AndroidJavaClass unityPlayer = new AndroidJavaClass("com.unity3d.player.UnityPlayer");
      AndroidJavaObject unityActivity = unityPlayer.GetStatic<AndroidJavaObject>("currentActivity");
      
      return unityActivity;
    }

    public AdlantisInterstitialNativeAndroid(string publisherId, string callbackName)
    {
      AndroidJavaObject unityActivity = getCurrentActivity();
      AdlantisUnityBridgeClass.CallStatic("initialize", unityActivity, publisherId, callbackName); 
    }
    
    
  
    static bool IsEmulator()
    {
      return Application.platform != RuntimePlatform.Android;
    }
  

    public override void Show()
    {
      AdlantisUnityBridgeClass.CallStatic("show");
    }
    
  }

#endif

}
