//
//  AdlantisInterstitialAdBinding.mm
//  AdLantis SDK
//
//  Copyright 2014 Glossom, inc. All rights reserved.
//
//
#import "AdlantisInterstitialAdBinding.h"

// void UnitySendMessage(const char* obj, const char* method, const char* msg);

@implementation AdlantisInterstitialAdListenerBinding

//
// turn src to a cstring, then copy it into dst
//
-(BOOL)NSStringToCString:(NSString*)src dst:(char **)dst
{
    if( src == NULL ) return NO;
    if( (*dst = (char *)malloc([src length])) == NULL ) return NO;
    
    strcpy(*dst, [src UTF8String]);
    
    return YES;
}

-(id)initWithName:(NSString *)callbackObjectName
{
    if ( self = [super init] ) {
        if (callbackObjectName != NULL ) {
            // [NSString UTF8String] will free the memory automatically.
            // we have to copy the string into unityCallbackObjectName
            [self NSStringToCString:callbackObjectName dst:&unityCallbackObjectName];
        }
    }
    
    return self;
}
- (void)interstitialAdRequestComplete:(AdlantisInterstitialAd*)interstitialAd
{
    if (unityCallbackObjectName != NULL) {
        UnitySendMessage(unityCallbackObjectName, "interstitialAdRequestComplete", "");
    }
}

- (void)interstitialAdRequestFailed:(AdlantisInterstitialAd*)interstitialAd
{
    if (unityCallbackObjectName != NULL) {
        UnitySendMessage(unityCallbackObjectName, "interstitialAdRequestFailed", "");
    }
}


- (void)interstitialAdWillBePresented:(AdlantisInterstitialAd*)interstitialAd
{
    if (unityCallbackObjectName != NULL) {
        UnitySendMessage(unityCallbackObjectName, "interstitialAdWillBePresented", "");
    }
}


- (void)interstitialAdWasDismissed:(AdlantisInterstitialAd*)interstitialAd
{
    if (unityCallbackObjectName != NULL) {
        UnitySendMessage(unityCallbackObjectName, "interstitialAdWasDismissed", "");
    }
}

@end

static AdlantisInterstitialAd * gAdlantisInterstitialAd = nil;
static AdlantisInterstitialAdListenerBinding *gAdlantisInterstitialAdListener = nil;

void _AdlantisIntersitial_Init(char * inPublisherId, char *callbackObjectName)
{
  if (gAdlantisInterstitialAd == nil) {
    gAdlantisInterstitialAd = [[AdlantisInterstitialAd interstitialAdWithPublisherId:@(inPublisherId)] retain];
    gAdlantisInterstitialAdListener = [[AdlantisInterstitialAdListenerBinding alloc] initWithName:@(callbackObjectName)];
    gAdlantisInterstitialAd.delegate = gAdlantisInterstitialAdListener;
  }
}

void _AdlantisIntersitial_Show()
{
  [gAdlantisInterstitialAd show];
}
void _AdlantisIntersitial_Cancel()
{
  [gAdlantisInterstitialAd cancel];
}
